#ifndef __ARCH_IA32_SMP__
#define __ARCH_IA32_SMP__

#define MAX_CPU		32

/* Defines a memory area to search for the MPS in */
typedef struct mps_region{
	u_int32_t	base;
	u_int32_t	length;
}mps_region_t;

typedef struct cpu_info {
	u_int32_t	features;
}cpu_info_t, *p_cpu_info;

typedef struct smp_info{
	char 		oem_id[12];
	char		prod_id[24];
	u_int32_t	local_apic;
	u_int32_t	cpu_count;

	cpu_info_t	cpu[MAX_CPU];
	u_int32_t	present_cpus;
	u_int32_t	boot_cpu;
}smp_info_t, *p_smp_info;
extern smp_info_t smpinfo;

/* Configuratioon table header */
typedef struct imps_cth
{
	unsigned sig;
	unsigned short base_length;
	unsigned char spec_rev;
	unsigned char checksum;
	char oem_id[8];
	char prod_id[12];
	unsigned oem_table_ptr;
	unsigned short oem_table_size;
	unsigned short entry_count;
	unsigned lapic_addr;
	unsigned short extended_length;
	unsigned char extended_checksum;
	char reserved[1];
}imps_cth_t, *p_imps_cth;

/* MP Floating Pointer Structure */
typedef struct imps_fps{
	u_int32_t	magic;
	p_imps_cth	cth;
	u_int8_t	len;
	u_int8_t	rev;
	u_int8_t	csum;
	u_int8_t	feature_info[5];
}imps_fps_t, *p_imps_fps;

/* Defines a CPU */
typedef struct imps_cpu {
	unsigned char type;         /* must be 0 */
	unsigned char apic_id;
	unsigned char apic_ver;
	unsigned char flags;
	unsigned signature;
	unsigned features;
	char reserved[8];
}imps_cpu_t, *p_imps_cpu;

int probe_smp(void);
void smp_read_imps(p_imps_fps);

typedef struct cpu_feature{
	u_int32_t	mask;
	char		*name;
}cpu_feature_t;

extern cpu_feature_t features[];

#endif /* __ARCH_IA32_SMP__ */
