#include <kernel.h>
#include <arch/mm.h>
#include <arch/setup.h>

u_int32_t pagefault_get_cr2(void)
{
	u_int32_t ret;
	asm("movl %%cr2, %0":"=r" (ret));
	return ret;
}

void pagefault(u_int32_t err)
{
	kprint("\nPage fault at 0x%x\n", pagefault_get_cr2());
	
	if ( pagefault_get_cr2() < PAGE_SIZE ) {
		kprint("Unable to handle NULL pointer dereference\n");
	}
	
	kprint(" * Fault was caused by a %s\n",
		MASK(err, 0) ? "page-level protection violation" : "non present page" );
	
	kprint(" * The access was a %s\n",
		MASK(err, 1) ? "write" : "read" );
	
	kprint(" * The fault was caused by the %s\n",
		MASK(err, 2) ? "kernel" : "user" );
	
	kprint(" * The access was %s caused by a reserved violation\n",
		MASK(err, 3) ? "" : "not" );	

	enter_to_exit();
	return;
}
