#include <kernel.h>
#include <arch/vga_bios.h>

static volatile unsigned char *vidmem;

void __init vga_bios_init(void)
{
	int i;
	vidmem = (unsigned char *)VIDMEM;
	
	koutput.xpos=0;
	koutput.xpos=0;
	koutput.put_char=vga_bios_put;
	koutput.set_cursor=vga_bios_curs;

	if (boot_info.monitor == MONITOR_MONO) 
		koutput.attrib=0x0007;
	else
		koutput.attrib=0x0017;

	/* Clear the screeen */
	for (i = 0; i < COLS * LINS * 2; i+=2) {
		*(vidmem + i) = 0;
		*(vidmem + i + 1) = koutput.attrib;
	}

	/* Set cursor to 0,0 */
	vga_bios_curs(0,0);
}

void vga_bios_put (u_int8_t c)
{
	switch(c) {
		case 8: /* Delete */
			
			/* Move our position back one */
			if ( koutput.xpos == 0 ) {
				if ( koutput.ypos ) koutput.ypos--;
				koutput.xpos=COLS-1;
			}else{
				koutput.xpos--;
			}
			
			/* Blank current position */
			*(vidmem+(koutput.xpos+koutput.ypos*COLS)*2)=' ';
			*(vidmem+(koutput.xpos+koutput.ypos*COLS)*2+1)=koutput.attrib;
			
			break;
			
		case '\n':
		case '\r':
newline:
			koutput.xpos = 0;
			koutput.ypos++;
			if (koutput.ypos >= LINS) {
				int i;
			
				/* Move all the lines up one */
				for ( i=COLS; i<((LINS)*COLS); i++ ) {
					*(vidmem + ((i-COLS))*2) = *(vidmem+ i*2);
				}
			
				/* Blank the last line */
				for ( i=0; i<COLS; i++) {
					*(vidmem+((LINS*COLS-COLS+i)*2))=' ';
					*(vidmem+((LINS*COLS-COLS+i)*2)+1)=koutput.attrib;
				}koutput.ypos--;
			}
			break;

		default:
			*(vidmem+(koutput.xpos+koutput.ypos*COLS)*2)=c;
			*(vidmem+(koutput.xpos+koutput.ypos*COLS)*2+1)=koutput.attrib;
			koutput.xpos++;
			if (koutput.xpos >= COLS) goto newline; /* Wrap the line */
			break;
	}
}

/* Set cursor position */
void vga_bios_curs ( u_int16_t x, u_int16_t y )
{
	u_int32_t vid_off;

	vid_off=(x+y*COLS)*2;
	vid_off >>=1;
	outb(0x3d4, 0x0f);
	outb(0x3d5, vid_off & 0xfff);
	outw(0x3d4, 0x0e);
	outb(0x3d5, vid_off >> 8);
}
