#ifndef __DRIVER_HEADER_INCLUDED__
#define __DRIVER_HEADER_INCLUDED__

#include <types.h>

typedef void (*proc_driver_init)(void);
typedef u_int32_t (*proc_driver_probe)(void); /* Returns number of devices found */
typedef u_int32_t (*proc_driver_setup)(void); /* Returns number of devices configured */

/* Resource types */
typedef enum res_type {
	RES_IO,		/* I/O port */
	RES_MEM,	/* Memory */
	RES_DMA,	/* DMA channel */
}res_type_t;

/* Defines a hardware resource */
typedef struct resource {
	res_type_t	type;
	u_int32_t	addr;
}resource_t, *p_resource;

/* A device driver */
typedef struct driver {
	char			*name;
	proc_driver_init	init;	/* Initialise driver */
	proc_driver_probe	probe;	/* Probe for devices */
	proc_driver_setup	setup;	/* Configure devices */
}driver_t, *p_driver;

#endif /* __DRIVER_HEADER_INCLUDED__ */
