#include <lib/malloc.h>
#include <lib/kprint.h>

void *kmalloc(u_int32_t mask, u_int32_t len)
{
	if ( len > PAGE_SIZE ) {
		kprint("Can't kmalloc more than %u bytes at a time\n", PAGE_SIZE);
		return 0;
	}

	return (void *)get_free_page(mask);
}

void kfree(void *addr)
{
	u_int32_t v=(u_int32_t)addr;
	if ( v ) unlock_page((u_int32_t)addr);
}
